var util_1 = require('../util');
function imputeTransform(model) {
    var stack = model.stack();
    return {
        type: 'impute',
        field: model.field(stack.fieldChannel),
        groupby: [model.field(stack.stackChannel)],
        orderby: [model.field(stack.groupbyChannel)],
        method: 'value',
        value: 0
    };
}
exports.imputeTransform = imputeTransform;
function stackTransform(model) {
    var stack = model.stack();
    var sortby = stack.config.sort === 'descending' ?
        '-' + model.field(stack.stackChannel) :
        stack.config.sort === 'ascending' ?
            model.field(stack.stackChannel) :
            util_1.isObject(stack.config.sort) ?
                stack.config.sort :
                '-' + model.field(stack.stackChannel);
    var valName = model.field(stack.fieldChannel);
    var transform = {
        type: 'stack',
        groupby: [model.field(stack.groupbyChannel)],
        field: model.field(stack.fieldChannel),
        sortby: sortby,
        output: {
            start: valName + '_start',
            end: valName + '_end'
        }
    };
    if (stack.config.offset) {
        transform.offset = stack.config.offset;
    }
    return transform;
}
exports.stackTransform = stackTransform;
//# sourceMappingURL=stack.js.map